SystemOrganization addCategory: #'btb-lazyCollections'!

TestCase subclass: #LazyCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-lazyCollections'!

!LazyCollectionTest commentStamp: '<historical>' prior: 0!
Copyright (c) 2004 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 10/10/2004 20:57!

!LazyCollectionTest class methodsFor: 'speed' stamp: 'btb 10/10/2004 20:41'!
testLazyTime
	"LazyCollectionTest testLazyTime"
	| original modified |
	original := (1 to: 1000000) asOrderedCollection.
	TimeProfileBrowser
		onBlock: [modified := original
						lazySelect: [:each | each even].
			modified := modified
						lazyReject: [:each | (each \\ 4) isZero].
			modified := modified
						lazyCollect: [:each | each printString].
			modified := modified
						lazySelect: [:each | each size == 1].
			modified := modified realize]! !

!LazyCollectionTest class methodsFor: 'speed' stamp: 'btb 10/10/2004 19:44'!
testRegularTime
	"LazyCollectionTest testRegularTime"
	| original modified |
	original := (1 to: 1000000) asOrderedCollection.
	TimeProfileBrowser
		onBlock: [
			modified := original
						select: [:each | each even].
			modified := modified
						reject: [:each | (each \\ 4) isZero].
			modified := modified
						collect: [:each | each printString].
			modified := modified
						select: [:each | each size == 1]]! !

!LazyCollectionTest methodsFor: 'tests' stamp: 'btb 10/10/2004 20:39'!
test
	| original modified modifiedEven realizedCollection |
	original := (1 to: 100) asOrderedCollection.
	modified := original
				lazySelect: [:each | each even].
	modifiedEven := modified.
	modified := modified
				lazyReject: [:each | (each \\ 4) isZero].
	modified := modified
				lazyCollect: [:each | each printString].
	modified := modified
				lazySelect: [:each | each size == 1].
	"force, the collection to be realized"
	realizedCollection := modified
				collect: [:each | each].
	self assert: realizedCollection
			= (OrderedCollection with: '2' with: '6').
	self assert: modifiedEven size = 50.
	self deny: (modifiedEven isKindOf: LazyCollection).
	! !

!LazyCollectionTest class methodsFor: 'documentation' stamp: 'btb 10/10/2004 21:06'!
documentation
	" 
	The idea for LazyCollection is very simple. It takes a functional  
	approach to the common collection protocol of select:, collect:, and  
	reject:. By functional, I mean the collection is not changed nor is a new 
	one created. The blocks are kept around until they are absolutely 
	needed. I have been wanting this functionality for some time because 
	it's nice for large collections. If you have a collection in which you are 
	calling a lot selects, rejects, or collects on, then this will not create 
	the intermediate collections. It will wait until you ask something of the 
	collection where it can not delay the answer. This should make these 
	chained operations must faster on large collections.  
	
	This was a lot of fun to program and it's not that big. Take whatever 
	you want from it!! 
	"
	^ self! !

!BlockContext methodsFor: '*btb-lazyCollections' stamp: 'btb 10/9/2004 21:34'!
negate

	^self argumentCount ==1
		ifTrue: [[:each | (self value: each) not]]
		ifFalse: [self error: 'Must call with a block with one argument']! !

Object subclass: #IgnoreObjectPlaceHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-lazyCollections'!

!IgnoreObjectPlaceHolder commentStamp: '<historical>' prior: 0!
Copyright (c) 2004 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 10/10/2004 20:57!

!IgnoreObjectPlaceHolder class methodsFor: 'public' stamp: 'btb 10/10/2004 19:31'!
isIgnorablePlaceHolder

	^true! !

!Object methodsFor: '*btb-lazyCollections' stamp: 'btb 10/10/2004 19:32'!
isIgnorablePlaceHolder

	^false! !

Object subclass: #LazyCollection
	instanceVariableNames: 'original monadicValuable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'btb-lazyCollections'!

!LazyCollection commentStamp: '<historical>' prior: 0!
Copyright (c) 2004 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 10/10/2004 20:57!

!LazyCollection methodsFor: 'public-collection' stamp: 'btb 10/10/2004 20:40'!
at: key 
	^ self realize at: key! !

!LazyCollection methodsFor: 'AUTO-GENERATED' stamp: 'btb 10/10/2004 20:41'!
select: aBlock 
	"AUTO-GENERATED"
	^ self realize select: aBlock! !

!LazyCollection methodsFor: 'public' stamp: 'btb 10/10/2004 15:31'!
lazyCollect: aBlock 
	^ self shallowCopy addCollect: aBlock! !

!LazyCollection methodsFor: 'public-collection' stamp: 'btb 10/10/2004 20:41'!
size
	^ self realize size! !

!LazyCollection class methodsFor: 'public' stamp: 'btb 10/10/2004 08:12'!
on: aCollection collect: aBlock 
	^ (self basicNew initializeWith: aCollection)
		addCollect: aBlock! !

!LazyCollection methodsFor: 'AUTO-GENERATED' stamp: 'btb 10/10/2004 20:40'!
do: elementBlock separatedBy: separatorBlock 
	"AUTO-GENERATED"
	^ self realize do: elementBlock separatedBy: separatorBlock! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 20:50'!
realize
	| result |
	result := original species new.
	self do: [:each | result add: each].
	self becomeForward: result.
	^ result! !

!LazyCollection methodsFor: 'AUTO-GENERATED' stamp: 'btb 10/10/2004 20:41'!
second
	"AUTO-GENERATED"
	^ self realize second! !

!LazyCollection methodsFor: 'public-collection' stamp: 'btb 10/10/2004 20:50'!
do: aBlock 
	original
		do: [:each | 
			| answer | 
			answer := monadicValuable value: each.
			answer isIgnorablePlaceHolder
				ifFalse: [aBlock value: answer]].! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 20:42'!
compileRealizeMessage: aMessage 
	| selector messageStream header |
	selector := aMessage selector.
	messageStream := String new writeStream.
	header := original species methodHeaderFor: selector.
	messageStream nextPutAll: header;
		 cr;
		 tab;
		 nextPutAll: '"AUTO-GENERATED"';
		 cr;
		 tab;
		 nextPutAll: '^self apply ';
		 nextPutAll: header.
	self class compile: messageStream contents classified: 'AUTO-GENERATED'! !

!LazyCollection methodsFor: 'AUTO-GENERATED' stamp: 'btb 10/10/2004 20:40'!
collect: aBlock 
	"AUTO-GENERATED"
	^ self realize collect: aBlock! !

!LazyCollection methodsFor: 'public' stamp: 'btb 10/10/2004 15:32'!
lazyReject: aBlock 
	^self shallowCopy addSelect: aBlock negate! !

!LazyCollection class methodsFor: 'public' stamp: 'btb 10/10/2004 08:13'!
on: aCollection select: aBlock 
	^ (self basicNew initializeWith: aCollection)
		addSelect: aBlock! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 20:53'!
initializeWith: aCollection 
	original := aCollection.
	monadicValuable := nil.! !

!LazyCollection methodsFor: 'public-collection' stamp: 'btb 10/10/2004 20:40'!
at: key put: value 
	^ self realize at: key put: value! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 20:41'!
doesNotUnderstand: aMessage 
	| selector |
	selector := aMessage selector.
	^ (original species canUnderstand: selector)
		ifTrue: [self compileRealizeMessage: aMessage.
			self realize perform: selector withArguments: aMessage arguments]
		ifFalse: [super doesNotUnderstand: aMessage]! !

!LazyCollection methodsFor: 'public' stamp: 'btb 10/10/2004 15:32'!
lazySelect: aBlock 
	^self shallowCopy addSelect: aBlock! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 11:53'!
addSelect: aBlock 
	self
		addMonadicValuable: [:each | (aBlock value: each)
				ifTrue: [each]
				ifFalse: [IgnoreObjectPlaceHolder]]! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 11:53'!
addCollect: aBlock 
	self addMonadicValuable: aBlock! !

!LazyCollection methodsFor: 'private' stamp: 'btb 10/10/2004 20:54'!
addMonadicValuable: aValuable 
	| current |
	current := monadicValuable.
	current isNil ifTrue: [monadicValuable := aValuable. ^self].
	monadicValuable := [:each | 
			| result | 
			result := current value: each.
			result isIgnorablePlaceHolder
				ifTrue: [result]
				ifFalse: [aValuable value: result]]! !

!LazyCollection methodsFor: 'AUTO-GENERATED' stamp: 'btb 10/10/2004 20:41'!
first
	"AUTO-GENERATED"
	^ self realize first! !

!Collection methodsFor: '*btb-lazyCollections' stamp: 'btb 10/9/2004 21:27'!
lazyCollect: aBlock 
	^ LazyCollection on: self collect: aBlock! !

!Collection methodsFor: '*btb-lazyCollections' stamp: 'btb 10/9/2004 21:27'!
lazySelect: aBlock 
	^ LazyCollection on: self select: aBlock! !

!Collection methodsFor: '*btb-lazyCollections' stamp: 'btb 10/9/2004 21:36'!
lazyReject: aBlock 
	^ LazyCollection on: self select: aBlock negate! !
